<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: home.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: home.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* @file Game Overview. Allows to create and manage plai games
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

const Swal = swal;

socket.on('connect', function(data) {
  console.log("get games")
  socket.get('games', {})
  .then(function(result) {
    if(result.length) {
      $('#game_table').children().not('#create').remove()
      for(let game of result) {
        addGame(game)
      }
    }
  })
})

$( document ).ready(function() {
  $('#create').prop('title', 'create game')
  $('#create').click(createGame)
})

/**
* create a game representing square button with edit, control and delete icon
*
* @todo add copy functionality
*
* @param {string} name - game name
*/
function addGame(name) {
  var $game_node = $('&lt;a id="' + name + '" class="square" title="' + name + '" href="/ui/' + name + '/editor">&lt;/a>')
  var $title = $('&lt;div class="square_content">' + name + '&lt;/div>')
  var $edit = $('&lt;a title="Edit" href="/ui/' + name + '/editor">&lt;i class="fa fa-wrench squareIcon">&lt;/i>&lt;/a>')
  var $ctrl = $('&lt;a title="Control" href="/ui/' + name + '/control/sessions#list">&lt;i class="fa fa-play-circle squareIcon">&lt;/i>')
  var $copy = $('&lt;i title="Copy" class="fa fa-copy squareIcon">&lt;/i>')
	var $del = $('&lt;i title="Delete" class="fa fa-trash-alt squareIcon">&lt;/i>')

  $title.prepend('&lt;br>&lt;br>')
  $title.append('&lt;br>&lt;br>')
  $title.append($edit)
  $title.append($ctrl)
  $title.append($del)
  $('.squareIcon').fadeTo(1,0)
  $game_node.append($title)
  
  $del.click(function() {
    confirmation("Are you sure you want to remove " + name + "?")
    .then(function(confirmed){
      if(confirmed) {
        socket.get('unload', {"title":name})
        .then(function(deleted) {
          if(deleted) {
            removeGame(name)
          }
        })
      }
    })
    return false
  })

  $copy.click(function() {
    inputPrompt("Enter name for duplicate of " + name, name + "_copy", function(copy_title) {
      if(copy_title) {

      }
    })
  })

  $game_node.mouseenter(function() {
    $('.squareIcon').fadeTo(100,1)
  })
  $game_node.mouseleave(function() {
    $('.squareIcon').fadeTo(100,0)
  })
  $('#game_table').prepend($game_node)
}

/**
* open name input and template dropdown
* create game on confirmation then add game squareIcon
*/
function createGame() {
  var content = document.createElement('div')
  var $name = $('&lt;input class="swal_form_content" value="new_game">')

  var $template = $('&lt;select title="Template" class="swal_form_content">')
  for (let option of ["basic","installation","multiplayer","open-world"]) {
    $("&lt;option/>").val(option).text(option).appendTo($template)
  }
  
  content.append("Set the new games name")
  $name.appendTo(content)
  content.append("Choose a template.")
  $template.appendTo(content)

  Swal({
    content: content,
    className:'swal_autosize',
    text:"Create Game",
    buttons: {
      cancel: true,
      confirm: true,
    },
  })
  .then((value) => {
    if(value &amp;&amp; $name.val() &amp;&amp; $template.val()) {
      socket.get('create', {"title":$name.val(),"template":$template.val()})
      .then(function(result) {
        console.log($name.val() + " " + result)
        addGame($name.val())
      })
    }
  })
}

/**
* remove game squareIcon
*
* @param {string} name - game name
*/
function removeGame(name) {
  $('#' + name).remove()
  console.log(name + " removed")
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
